Subject: Re: bug#3454: <SPC> when reading the emacs manual sometimes goes to the wrong node

From: Shannon Jones <[email-masked]>
Date: Wed, 3 Jun 2009 13:15:47 -0500

On Wed, Jun 3, 2009 at 10:39 AM, Eli Zaretskii <[email-masked]> wrote:
>> Date: Wed, 3 Jun 2009 00:40:37 -0500
>> From: Shannon Jones <[email-masked]>
>> Cc:
>> Reply-To: Shannon Jones <[email-masked]>, [email-masked]
>>
>> Run emacs -Q
>> C-h r (Reads emacs manual)
>> g Command Index (takes you to the "Command and Function Index" page of the
>> manual)
>> M-> (Go to end of info node)
>>
>> At this point, your cursor should be at the end of the info node that lists
>> all commands and functions.  Note that at the top, the next node is listed
>> as "Variable Index".  I would expect that pressing <SPC> would take you to
>> this node.  However, if you press <SPC> it takes you to some other node.  It
>> takes me to the middle of the node "49 Two-Column Editing".

> This is not a bug: SPC does _not_ necessarily go to the Next node;
> instead, it traverses the nodes as a tree: if there is a menu in the
> current node, it takes you to the first menu item of that menu.

Thanks for the quick response :-)

I see what my problem was now.  Each item listed in the Index is a
subnode of the Index.  So pressing <SPC> at the bottom of the Index
page will take me to the first item listed in the Index.  I was
expecting it to take me to the Next node in the manual, since I didn't
realize that the index entries were considered subnodes.

>> According to the manual for Info, "You can read an entire manual top to
>> bottom by just typing <SPC>".
>
> Right, but by going to the Next node you will not end up reading the
> whole manual, because Next does not descend to sections, subsections,
> subsubsections, etc.  SPC does, so it does indeed guarantee that you
> end up reading the whole manual in the logical order: before you move
> to the next chapter, you read all the sections and subsections of the
> current chapter.

Unfortunately, pressing <SPC> does not allow you to traverse the whole
emacs manual from top to bottom, like the Info manual says it will.
If you go to the top node of the manual (C-h r) and press space
repeatedly, you follow this path:

Table of Contents
Distribution
Introduction
Glossary
Key (Character) Index
37.8 Shell Commands in Dired
37.9 ... Appendix G
GNU Manifesto
Then cycles back to Distribution

Note that you skip sections 1..36 completely, and most of 37.

By having the index near the beginning, it messes up navigation a bit.
 But it only impacts odd people like me who read the manual from the
beginning :-)  That's how I noticed this.  I was paging through the
manual from the beginning, and suddenly found myself skipping over
most of the manual.

> I'm closing this report.

That's fine, I agree it's not a bug.  I'll just remember to hit 'n' at
the bottom of indexes instead of <SPC>.